const MAIN_BLOCK="dual-listbox",CONTAINER_ELEMENT="dual-listbox__container",AVAILABLE_ELEMENT="dual-listbox__available",SELECTED_ELEMENT="dual-listbox__selected",TITLE_ELEMENT="dual-listbox__title",ITEM_ELEMENT="dual-listbox__item",BUTTONS_ELEMENT="dual-listbox__buttons",BUTTON_ELEMENT="dual-listbox__button",SEARCH_ELEMENT="dual-listbox__search",SELECTED_MODIFIER="dual-listbox__item--selected",DIRECTION_UP="up",DIRECTION_DOWN="down";
class DualListbox{constructor(a,b={}){this.setDefaults();this.dragged=null;this.options=[];DualListbox.isDomElement(a)?this.select=a:this.select=document.querySelector(a);this._initOptions(b);this._initReusableElements();void 0!==b.options?this.options=b.options:this._splitOptions(this.select.options);this._buildDualListbox(this.select.parentNode);this._addActions();this.showSortButtons&&this._initializeSortButtons();this.redraw()}setDefaults(){this.availableTitle="Available options";this.selectedTitle=
"Selected options";this.showAddButton=!0;this.addButtonText="add";this.showRemoveButton=!0;this.removeButtonText="remove";this.showAddAllButton=!0;this.addAllButtonText="add all";this.showRemoveAllButton=!0;this.removeAllButtonText="remove all";this.searchPlaceholder="Search";this.showSortButtons=!1;this.sortFunction=(a,b)=>0;this.upButtonText="up";this.downButtonText="down";this.draggable=this.enableDoubleClick=!0}changeOrder(a,b){var c=this.options.findIndex(d=>d.value===a.dataset.id);c=this.options.splice(c,
1);this.options.splice(b,0,c[0])}addOptions(a){a.forEach(b=>{this.addOption(b)})}addOption(a,b=null){b?this.options.splice(b,0,a):this.options.push(a)}addEventListener(a,b){this.dualListbox.addEventListener(a,b)}changeSelected(a){const b=this.options.find(c=>c.value===a.dataset.id);b.selected=!b.selected;this.redraw();setTimeout(()=>{let c=document.createEvent("HTMLEvents");b.selected?(c.initEvent("added",!1,!0),c.addedElement=a):(c.initEvent("removed",!1,!0),c.removedElement=a);this.dualListbox.dispatchEvent(c)},
0)}actionAllSelected(a){a&&a.preventDefault();this.options.forEach(b=>b.selected=!0);this.redraw()}actionAllDeselected(a){a&&a.preventDefault();this.options.forEach(b=>b.selected=!1);this.redraw()}redraw(){this.options.sort(this.sortFunction);this.updateAvailableListbox();this.updateSelectedListbox();this.syncSelect()}searchLists(a,b){b=b.querySelectorAll(`.${ITEM_ELEMENT}`);a=a.toLowerCase();for(let c=0;c<b.length;c++){let d=b[c];-1===d.textContent.toLowerCase().indexOf(a)?d.style.display="none":
d.style.display="list-item"}}updateAvailableListbox(){this._updateListbox(this.availableList,this.options.filter(a=>!a.selected))}updateSelectedListbox(){this._updateListbox(this.selectedList,this.options.filter(a=>a.selected))}syncSelect(){for(;this.select.firstChild;)this.select.removeChild(this.select.lastChild);this.options.forEach(a=>{let b=document.createElement("option");b.value=a.value;b.innerText=a.text;a.selected&&b.setAttribute("selected","selected");this.select.appendChild(b)})}_updateListbox(a,
b){for(;a.firstChild;)a.removeChild(a.firstChild);b.forEach(c=>{a.appendChild(this._createListItem(c))})}actionItemSelected(a){a.preventDefault();(a=this.availableList.querySelector(`.${SELECTED_MODIFIER}`))&&this.changeSelected(a)}actionItemDeselected(a){a.preventDefault();(a=this.selectedList.querySelector(`.${SELECTED_MODIFIER}`))&&this.changeSelected(a)}_actionItemDoubleClick(a,b=null){b&&(b.preventDefault(),b.stopPropagation());this.enableDoubleClick&&this.changeSelected(a)}_actionItemClick(a,
b,c=null){c&&c.preventDefault();b=b.querySelectorAll(`.${ITEM_ELEMENT}`);for(c=0;c<b.length;c++){let d=b[c];d!==a&&d.classList.remove(SELECTED_MODIFIER)}a.classList.contains(SELECTED_MODIFIER)?a.classList.remove(SELECTED_MODIFIER):a.classList.add(SELECTED_MODIFIER)}_addActions(){this._addButtonActions();this._addSearchActions()}_addButtonActions(){this.add_all_button.addEventListener("click",a=>this.actionAllSelected(a));this.add_button.addEventListener("click",a=>this.actionItemSelected(a));this.remove_button.addEventListener("click",
a=>this.actionItemDeselected(a));this.remove_all_button.addEventListener("click",a=>this.actionAllDeselected(a))}_addClickActions(a){a.addEventListener("dblclick",b=>this._actionItemDoubleClick(a,b));a.addEventListener("click",b=>this._actionItemClick(a,this.dualListbox,b));return a}_addSearchActions(){this.search_left.addEventListener("change",a=>this.searchLists(a.target.value,this.availableList));this.search_left.addEventListener("keyup",a=>this.searchLists(a.target.value,this.availableList));
this.search_right.addEventListener("change",a=>this.searchLists(a.target.value,this.selectedList));this.search_right.addEventListener("keyup",a=>this.searchLists(a.target.value,this.selectedList))}_buildDualListbox(a){this.select.style.display="none";this.dualListBoxContainer.appendChild(this._createList(this.search_left,this.availableListTitle,this.availableList));this.dualListBoxContainer.appendChild(this.buttons);this.dualListBoxContainer.appendChild(this._createList(this.search_right,this.selectedListTitle,
this.selectedList));this.dualListbox.appendChild(this.dualListBoxContainer);a.insertBefore(this.dualListbox,this.select)}_createList(a,b,c){let d=document.createElement("div");d.appendChild(a);d.appendChild(b);d.appendChild(c);return d}_createButtons(){this.buttons=document.createElement("div");this.buttons.classList.add(BUTTONS_ELEMENT);this.add_all_button=document.createElement("button");this.add_all_button.innerHTML=this.addAllButtonText;this.add_button=document.createElement("button");this.add_button.innerHTML=
this.addButtonText;this.remove_button=document.createElement("button");this.remove_button.innerHTML=this.removeButtonText;this.remove_all_button=document.createElement("button");this.remove_all_button.innerHTML=this.removeAllButtonText;const a={showAddAllButton:this.add_all_button,showAddButton:this.add_button,showRemoveButton:this.remove_button,showRemoveAllButton:this.remove_all_button};for(let b in a)if(b){const c=this[b],d=a[b];d.setAttribute("type","button");d.classList.add(BUTTON_ELEMENT);c&&
this.buttons.appendChild(d)}}_createListItem(a){let b=document.createElement("li");b.classList.add(ITEM_ELEMENT);b.innerHTML=a.text;b.dataset.id=a.value;this._liListeners(b);this._addClickActions(b);this.draggable&&b.setAttribute("draggable","true");return b}_liListeners(a){a.addEventListener("dragstart",b=>{this.dragged=b.currentTarget;b.currentTarget.classList.add("dragging")});a.addEventListener("dragend",b=>{b.currentTarget.classList.remove("dragging")});a.addEventListener("dragover",b=>{b.preventDefault()},
!1);a.addEventListener("dragenter",b=>{b.target.classList.add("drop-above")});a.addEventListener("dragleave",b=>{b.target.classList.remove("drop-above")});a.addEventListener("drop",b=>{b.preventDefault();b.stopPropagation();b.target.classList.remove("drop-above");let c=this.options.findIndex(d=>d.value===b.target.dataset.id);b.target.parentElement!==this.dragged.parentElement&&this.changeSelected(this.dragged);this.changeOrder(this.dragged,c);this.redraw()})}_createSearchLeft(){this.search_left=document.createElement("input");
this.search_left.classList.add(SEARCH_ELEMENT);this.search_left.placeholder=this.searchPlaceholder}_createSearchRight(){this.search_right=document.createElement("input");this.search_right.classList.add(SEARCH_ELEMENT);this.search_right.placeholder=this.searchPlaceholder}_createDragListeners(){[this.availableList,this.selectedList].forEach(a=>{a.addEventListener("dragover",b=>{b.preventDefault()},!1);a.addEventListener("dragenter",b=>{b.target.classList.add("drop-in")});a.addEventListener("dragleave",
b=>{b.target.classList.remove("drop-in")});a.addEventListener("drop",b=>{b.preventDefault();b.target.classList.remove("drop-in");(a.classList.contains("dual-listbox__selected")||a.classList.contains("dual-listbox__available"))&&this.changeSelected(this.dragged)})})}_initOptions(a){for(let b in a)a.hasOwnProperty(b)&&(this[b]=a[b])}_initReusableElements(){this.dualListbox=document.createElement("div");this.dualListbox.classList.add(MAIN_BLOCK);this.select.id&&this.dualListbox.classList.add(this.select.id);
this.dualListBoxContainer=document.createElement("div");this.dualListBoxContainer.classList.add(CONTAINER_ELEMENT);this.availableList=document.createElement("ul");this.availableList.classList.add(AVAILABLE_ELEMENT);this.selectedList=document.createElement("ul");this.selectedList.classList.add(SELECTED_ELEMENT);this.availableListTitle=document.createElement("div");this.availableListTitle.classList.add(TITLE_ELEMENT);this.availableListTitle.innerText=this.availableTitle;this.selectedListTitle=document.createElement("div");
this.selectedListTitle.classList.add(TITLE_ELEMENT);this.selectedListTitle.innerText=this.selectedTitle;this._createButtons();this._createSearchLeft();this._createSearchRight();this.draggable&&setTimeout(()=>{this._createDragListeners()},10)}_splitOptions(a){[...a].forEach((b,c)=>{this.addOption({text:b.innerHTML,value:b.value,selected:b.attributes.selected||!1,order:c})})}_initializeSortButtons(){const a=document.createElement("button");a.classList.add("dual-listbox__button");a.innerText=this.upButtonText;
a.addEventListener("click",d=>this._onSortButtonClick(d,DIRECTION_UP));const b=document.createElement("button");b.classList.add("dual-listbox__button");b.innerText=this.downButtonText;b.addEventListener("click",d=>this._onSortButtonClick(d,DIRECTION_DOWN));const c=document.createElement("div");c.classList.add("dual-listbox__buttons");c.appendChild(a);c.appendChild(b);this.dualListBoxContainer.appendChild(c)}_onSortButtonClick(a,b){a.preventDefault();const c=this.dualListbox.querySelector(".dual-listbox__item--selected");
this.options.find(d=>d.value===c.dataset.id);c&&(a=this._getNewIndex(c,b),0<=a&&(this.changeOrder(c,a),this.redraw()))}_getNewIndex(a,b){const c=this.options.findIndex(e=>e.value===a.dataset.id);let d=c;DIRECTION_UP===b?--d:DIRECTION_DOWN===b&&c<a.length-1&&(d+=1);return d}static isDomElement(a){return"object"===typeof HTMLElement?a instanceof HTMLElement:a&&"object"===typeof a&&null!==a&&1===a.nodeType&&"string"===typeof a.nodeName}}window.DualListbox=DualListbox;
